package com.iformall.controller;

import com.iformall.common.ErrorCode;
import com.iformall.common.ResultData;
import com.iformall.domain.po.WxCoupon;
import com.iformall.domain.vo.WxCouponCVo;
import com.iformall.enums.EnumCouponChannelActivityStatus;
import com.iformall.enums.EnumCouponChannelType;
import com.iformall.service.WxCouponChannelService;
import com.iformall.service.WxCouponService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

@RestController
@RequestMapping("/api/wxCoupon")
@Api(description = "券类型相关接口")
public class WxCouponController extends BaseController {
    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private WxCouponChannelService wxCouponChannelService;
    @Autowired
    private WxCouponService wxCouponService;


    @ApiOperation("根据id(couponChannel)查询接口")
    @GetMapping("/detail")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "couponChannelId", value = "couponChannelId", dataType = "String", paramType = "query", required = true)})
    public ResultData detailC(String couponChannelId) {
        if (StringUtils.isBlank(couponChannelId)) {
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "couponChannelId为空");
        }
        Long couponChannelIdL = 0L;
        try {
            couponChannelIdL = Long.valueOf(couponChannelId);
        } catch (NumberFormatException e) {
            logger.error("id转换失败" + couponChannelId);
            return new ResultData(ErrorCode.SYS_PARAMETER_NOT_NULL.getCode(), "couponChannelId转换失败" + couponChannelId);
        }

        WxCouponCVo wxCouponCVo = wxCouponChannelService.findDetailVo(couponChannelIdL);
        if (wxCouponCVo == null)
            return new ResultData(ErrorCode.COUPON_IS_EMPTY);

        if (wxCouponCVo.getTargetAd()!= null &&
                wxCouponCVo.getTargetAd().equals(EnumCouponChannelType.COUPON_CHANNEL_ID_TIMED.getCode())) {
            Date now = new Date();

            if (wxCouponCVo.getBeginTime().getTime() > now.getTime()) {
                wxCouponCVo.setActivityStatus(EnumCouponChannelActivityStatus.PREPARED.getCode());
            } else if (wxCouponCVo.getEndTime().getTime() < now.getTime()) {
                wxCouponCVo.setActivityStatus(EnumCouponChannelActivityStatus.ENDED.getCode());
            } else {
                wxCouponCVo.setActivityStatus(EnumCouponChannelActivityStatus.STARTED.getCode());
            }
        }

        return new ResultData(wxCouponCVo);
    }

    @ApiOperation("分页列表接口")
    @GetMapping("list")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页数", dataType = "int", paramType = "query", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页条数", dataType = "int", paramType = "query", required = true)})
    public ResultData list(@ModelAttribute WxCoupon wxCoupon, Integer pageNum, Integer pageSize) {
        logger.debug("[" + getIpAddr() + "] WxCouponController::list");
        if (wxCoupon == null) wxCoupon = new WxCoupon();
        wxCoupon.setTenantId(getTenantId());
        return wxCouponService.list(wxCoupon, pageNum, pageSize); //全列表
    }

}
